! TR 15581, sec. 2.3: allocatable function results

program f2003_tr15581_2
  implicit none
  print *, roots ( (/ 1.0, 4.0, 9.0, -1.0 /) )

contains

  function roots (x)
    real, intent(in)  :: x(:)
    real, allocatable :: roots(:)
    allocate (roots(size (x)))
    where (x > 0.0)
       roots = sqrt (x)
    elsewhere
       roots = 0
    end where
  end function roots
end program f2003_tr15581_2
