program f2003_move_alloc
  implicit none

  real, allocatable :: grid(:), tempgrid(:)
  integer :: n, i

  n = 3
  allocate (grid(1:n))                 ! Initial grid
  grid = (/ (real (i), i=1,n) /)

  allocate (tempgrid(1:2*n))           ! Allocate bigger grid
  tempgrid(::2)  = grid                ! Distribute values to new locations
  tempgrid(2::2) = grid + 0.5
  call MOVE_ALLOC (from=tempgrid, to=grid)

  if (size (grid) /= 2*n .or. allocated (tempgrid)) then
     print *, "Failure in move_alloc!"
  end if
  print '(99f8.3)', grid
end program f2003_move_alloc
