! A simple example with procedure pointers

real function foo1(x)
  implicit none
  real, intent(in) :: x
  foo1 = 2.0*x
end function foo1

real function foo2(x)
  implicit none
  real, intent(in) :: x
  foo2 = 4.0*x
end function foo2

program f2003_procptr_1
  implicit none
  real      :: pi = 3.14159265
!  intrinsic :: sin, cos
  real, external :: foo1, foo2

  procedure(real), pointer :: p => NULL ()

!  p => sin
!  print *, "sin(0), sin(pi/2) =", p(0.0), p(pi/2)

!  p => cos
!  print *, "cos(0), cos(pi)   =", p(0.0), p(pi)

  p => foo1
  print *, "foo1(0), foo1(pi/2) =", p(0.0), p(pi/2)

  p => foo2
  print *, "foo2(0), foo2(pi)   =", p(0.0), p(pi)

end program f2003_procptr_1
