! Procedure pointers in derived types and abstract interfaces as templates

module f2003_procptr_aux
  implicit none
contains

  INTEGER FUNCTION F1(I)
    INTEGER :: I
    f1=1+100*I
  END FUNCTION F1

  INTEGER FUNCTION F2(I)
    INTEGER :: I
    f2=2+100*I
  END FUNCTION F2

end module f2003_procptr_aux

program f2003_procptr_2
  use f2003_procptr_aux
  implicit none

  ABSTRACT INTERFACE
     INTEGER FUNCTION testproc(I)
       INTEGER :: I
     END FUNCTION testproc
  END INTERFACE

  TYPE fs
     PROCEDURE(testproc), NOPASS, POINTER :: p_ptr => NULL ()
  END TYPE fs

  TYPE(fs) :: a(2)
  a(1)%p_ptr=>f1
  a(2)%p_ptr=>f2
  write(6,*) a(1)%p_ptr(i=1)
  write(6,*) a(2)%p_ptr(i=2)

end program f2003_procptr_2
