module a
  implicit none
  integer, volatile :: neval = 0
contains
  subroutine inc_eval
    neval = neval + 1
  end subroutine inc_eval
end module a

program f2003_volatile
  use a
  implicit none
  real :: x = 1, y = 1, t
  neval = 0
  t = g(x)*g(y) + g(x)*g(y)
  if (neval == 4 .and. t == 2.0) then
     print *, "OK"
  else
     print *, "Funny, neval =", neval, " t =", t
  end if
contains
  function g(x)
    real             :: g    ! g is not pure, it has a side-effect!
    real, intent(in) :: x
    call inc_eval
    g = x
  end function g
end program f2003_volatile
